{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.Textract.Types.FeatureType
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.Textract.Types.FeatureType
  ( FeatureType
      ( ..,
        FeatureType_FORMS,
        FeatureType_QUERIES,
        FeatureType_SIGNATURES,
        FeatureType_TABLES
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

newtype FeatureType = FeatureType'
  { fromFeatureType ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern FeatureType_FORMS :: FeatureType
pattern FeatureType_FORMS = FeatureType' "FORMS"

pattern FeatureType_QUERIES :: FeatureType
pattern FeatureType_QUERIES = FeatureType' "QUERIES"

pattern FeatureType_SIGNATURES :: FeatureType
pattern FeatureType_SIGNATURES = FeatureType' "SIGNATURES"

pattern FeatureType_TABLES :: FeatureType
pattern FeatureType_TABLES = FeatureType' "TABLES"

{-# COMPLETE
  FeatureType_FORMS,
  FeatureType_QUERIES,
  FeatureType_SIGNATURES,
  FeatureType_TABLES,
  FeatureType'
  #-}
